!= ҥȥǡ
!
!= History data output
!
! Authors::   Yasuhiro MORIKAWA
! Version::   $Id: history_file_io.F90,v 1.2 2008-10-20 19:26:51 morikawa Exp $ 
! Tag Name::  $Name: dcpam5-20081118 $
! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
! License::   See COPYRIGHT[link:../../../COPYRIGHT]
!

module history_file_io
  !
  != ҥȥǡ
  !
  != History data output
  !
  ! <b>Note that Japanese and English are described in parallel.</b>
  !
  ! ҥȥǡϤν, ʹ, Ͽѿɽ
  ! λԤޤ. 
  ! [gt4f90io 饤֥]{http://www.gfd-dennou.org/library/gtool4}  
  ! gtool_historyauto ⥸塼Ѥޤ. 
  ! 
  ! ƥǡνϤ, ǥγƥץˤ, 
  ! gtool_historyauto ⥸塼뤫󶡤
  ! HistoryAutoAddVariable  HistoryAutoPut Ѥޤ. 
  !

  ! ⥸塼 ; USE statements
  !

  ! ʻ
  ! Grid points settings
  !
  use gridset, only: nmax, & ! ȿ. 
                             ! Maximum truncated wavenumber
    &                imax, & ! ٳʻ. 
                             ! Number of grid points in longitude
    &                jmax, & ! ٳʻ. 
                             ! Number of grid points in latitude
    &                kmax    ! ľؿ. 
                             ! Number of vertical level

  ! ̷ѥ᥿
  ! Kind type parameter
  !
  use dc_types, only: DP, &    ! ټ¿. Double precision. 
    &                 STRING, &  ! ʸ.       Strings. 
    &                 TOKEN      ! .   Keywords. 

  ! å
  ! Message output
  !
  use dc_message, only: MessageNotify

  ! ʸ ; Declaration statements
  !
  implicit none
  private
#ifdef LIB_MPI
  ! MPI 饤֥
  ! MPI library
  !
  include 'mpif.h'
#endif

  ! ³
  ! Public procedure
  !
  public:: HistoryFileOpen, HistoryFileClose

  ! ѿ
  ! Public variables
  !
  logical, save, public:: history_file_io_inited = .false.
                              ! ե饰. 
                              ! Initialization flag

  ! ѿ
  ! Private variables
  !
  real,         save:: DefaultIntValue
                              ! ҥȥǡνϴֳ֤ο (ǥե). 
                              ! Numerical value for interval of history data output (default value)
  character(12), save:: DefaultIntUnit
                              ! ҥȥǡνϴֳ֤ñ (ǥե). 
                              ! Unit for interval of history data output (default value)
  character(STRING):: DefaultFilePrefix
                              ! ҥȥǡΥե̾Ƭ (ǥե). 
                              ! Prefixes of history data filenames (default value)

!!$  namelist /history_file_io_nml/ 

  character(*), parameter:: module_name = 'history_file_io'
                              ! ⥸塼̾. 
                              ! Module name
  character(*), parameter:: version = &
    & '$Name: dcpam5-20081118 $' // &
    & '$Id: history_file_io.F90,v 1.2 2008-10-20 19:26:51 morikawa Exp $'
                              ! ⥸塼ΥС
                              ! Module version

  ! INTERFACE ʸ ; INTERFACE statements
  !
  interface HistoryFileOpen
    module procedure HistoryFileOpen
  end interface

  interface HistoryFileClose
    module procedure HistoryFileClose
  end interface

contains

  !-------------------------------------------------------------------

  subroutine HistoryFileOpen
    !
    ! history_file_io ⥸塼νԤޤ. 
    !--
    ! NAMELIST#history_file_io_nml ɤ߹ߤϤμ³ǹԤޤ. 
    !++
    !
    ! "history_file_io" module is initialized. 
    !--
    ! "NAMELIST#history_file_io_nml" is loaded in this procedure. 
    !++
    !

    ! ⥸塼 ; USE statements
    !

    ! ϥեδܾ
    ! Basic information for output files
    ! 
    use fileset, only: &
      & FileTitle, &
                              ! ϥǡեɽ.
                              ! Title of output data files
      & FileSource, &
                              ! ǡեμ. 
                              ! Source of data file
      & FileInstitution
                              ! ǡեǽŪѹȿ/Ŀ. 
                              ! Institution or person that changes data files for the last time

    ! ʪ
    ! Physical constants settings
    !
    use constants, only: PI   ! $ \pi $ .
                              ! ߼Ψ.  Circular constant

    ! ɸǡ
    ! Axes data settings
    !
    use axesset, only: &
#ifdef LIB_MPI
      & x_Lon_wholeMPI, &
                              ! $ \lambda $ [rad.] . . Longitude
      & y_Lat_wholeMPI, &
                              ! $ \varphi $ [rad.] . . Latitude
      & z_Sigma_wholeMPI, &
                              ! $ \sigma $ ٥ (). 
                              ! Full $ \sigma $ level
      & r_Sigma_wholeMPI, &
                              ! $ \sigma $ ٥ (Ⱦ). 
                              ! Half $ \sigma $ level
#endif
      & x_Lon, &
                              ! $ \lambda $ [rad.] . . Longitude
      & x_Lon_Weight, &
                              ! $ \Delta \lambda $ [rad.] . 
                              ! ٺɸŤ. 
                              ! Weight of longitude
      & y_Lat, &
                              ! $ \varphi $ [rad.] . . Latitude
      & y_Lat_Weight, &
                              ! $ \Delta \varphi $ [rad.] . 
                              ! ٺɸŤ. 
                              ! Weight of latitude
      & z_Sigma, &
                              ! $ \sigma $ ٥ (). 
                              ! Full $ \sigma $ level
      & r_Sigma, &
                              ! $ \sigma $ ٥ (Ⱦ). 
                              ! Half $ \sigma $ level
      & z_DelSigma, &
                              ! $ \Delta \sigma $ (). 
                              ! $ \Delta \sigma $ (Full)
      & w_Number
                              ! ڥȥǡźֹ. 
                              ! Subscript of spectral data


    ! NAMELIST եϤ˴ؤ桼ƥƥ
    ! Utilities for NAMELIST file input
    !
    use namelist_util, only: namelist_filename, NmlutilMsg

    ! 
    ! Time control
    !
    use timeset, only: StartTime, EndTime, StartDate, StartDateValid

    ! gtool4 netCDF ǡϥ󥿡ե (絬ϥǥ)
    ! Interface of Input/Output of gtool4 netCDF data (For large models)
    !
    use gtool_historyauto, only: HistoryAutoCreate, &
      & HistoryAutoAddAttr, HistoryAutoAddWeight, HistoryAutoPutAxis, &
      & HistoryAutoPutAxisMPI

    ! ե
    ! File I/O support
    !
    use dc_iounit, only: FileOpen

    ! դӻμ갷
    ! Date and time handler
    !
    use dc_date_types, only: DC_DIFFTIME
                              ! κɽǡ. 
                              ! Data type for difference about date and time
    use dc_date, only: DCDiffTimeCreate

    ! ʸ
    ! Character handling
    !
    use dc_string, only: StoA, CPrintf

    ! ̷ѥ᥿
    ! Kind type parameter
    !
    use dc_types, only: STDOUT ! ɸϤֹ. Unit number of standard output

    ! ʸ ; Declaration statements
    !
    implicit none

    ! ѿ
    ! Work variables
    !
    type(DC_DIFFTIME):: DefaultInt
    logical:: flag_mpi_init
#ifdef LIB_MPI
    integer:: err_mpi
#endif

    ! ¹ʸ ; Executable statement
    !

    if ( history_file_io_inited ) return
    call InitCheck

    ! ǥեͤ
    ! Default values settings
    !
    DefaultIntValue = 1.0
    DefaultIntUnit  = 'day'
    DefaultFilePrefix = ''
!!$    DefaultIntValue = 1.0
!!$    DefaultIntUnit  = 'hrs'
!!$    DefaultFilePrefix = 'data01/'

    call DCDiffTimeCreate( DefaultInt, &  ! (out)
      & DefaultIntValue, DefaultIntUnit ) ! (in)

#ifdef LIB_MPI
    ! MPI ˤԤƤ뤫ǧ. 
    ! Confirm initialization of MPI
    !
    call MPI_Initialized(flag_mpi_init, err_mpi)
#else
    flag_mpi_init = .false.
#endif

    ! HistoryAutoCreate ˤ
    ! Initialization by "HistoryAutoCreate"
    !
    call HistoryAutoCreate( &
      &     title = trim(FileTitle) // ' history data', &          ! (in)
      &    source = FileSource, institution = FileInstitution, &   ! (in)
      &      dims = (/ 'lon ', 'lat ', 'sig ', 'sigm', &
      &                'wn  ', 'time' /), &                        ! (in)
      &  dimsizes = (/ imax, jmax, kmax, kmax + 1, &
      &                (nmax+1)**2, 0 /), &                        ! (in)
      & longnames = (/ 'longitude                             ', &
      &                'latitude                              ', &
      &                'sigma at layer midpoints              ', &
      &                'sigma at layer end-points (half level)', &
      &                'subscript of spectral data            ', &
      &                'time                                  ' /), & ! (in)
      &     units = (/ 'degree_east ', 'degree_north', &
      &                '1           ', '1           ', &
      &                '1           ', DefaultIntUnit /), &        ! (in)
      &     xtypes = (/ 'float', 'float', &
      &                 'float', 'float', &
      &                 'int  ', 'float' /), &                     ! (in)
      &           origin = StartTime, &                        ! (in) optional
      &         terminus = EndTime, &                          ! (in) optional
      &         interval = DefaultInt, &                       ! (in) optional
      &      origin_date = StartDate, &                        ! (in) optional
      & origin_date_invalid = .not. StartDateValid, &          ! (in) optional
!!$      &     slice_start  = (/ 1.0, 1.0, 1.0, 1.0, 1.0 /), & ! (in) optional
!!$      &     slice_end    = (/ 0.0, 0.0, 0.0, 0.0, 0.0 /), & ! (in) optional
!!$      &     slice_stride = (/   1,   1,   1,   1,   1 /), & ! (in) optional
!!$      &    space_average = (/ .false., .false., .false., &
!!$      &                       .false., .false. /), &        ! (in) optional
!!$      & newfile_interval = real( delta_time * 10 ), &       ! (in) optional
      &  flag_mpi_gather = flag_mpi_init, &                    ! (in) optional
      &      file_prefix = DefaultFilePrefix, &                ! (in) optional
      & namelist_filename = namelist_filename )                ! (in) optional


    ! ɸǡؤ°
    ! Attributes of axes data settings
    !
    call HistoryAutoAddAttr( &
      & varname = 'lon', attrname = 'standard_name', &   ! (in)
      & value = 'longitude' )                            ! (in)
    call HistoryAutoAddAttr( &
      & varname = 'lat', attrname = 'standard_name', &   ! (in)
      & value = 'latitude' )                             ! (in)
    call HistoryAutoAddAttr( &
      & varname = 'sig', attrname = 'standard_name', &   ! (in)
      & value = 'atmosphere_sigma_coordinate' )          ! (in)
    call HistoryAutoAddAttr( &
      & varname = 'sigm', attrname = 'standard_name', &  ! (in)
      & value = 'atmosphere_sigma_coordinate' )          ! (in)
    call HistoryAutoAddAttr( &
      & varname = 'sig', attrname = 'positive', &        ! (in)
      & value = 'down' )                                 ! (in)
    call HistoryAutoAddAttr( &
      & varname = 'sigm', attrname = 'positive', &       ! (in)
      & value = 'down' )                                 ! (in)

    ! ɸǡ
    ! Axes data settings
    !
    call HistoryAutoPutAxis( &
      & dim = 'lon',  array = x_Lon / PI * 180.0_DP )  ! (in)
    call HistoryAutoPutAxis( &
      & dim = 'lat',  array = y_Lat / PI * 180.0_DP )  ! (in)
    call HistoryAutoPutAxis( &
      & dim = 'sig',  array = z_Sigma )                ! (in)
    call HistoryAutoPutAxis( &
      & dim = 'sigm', array = r_Sigma )                ! (in)
    call HistoryAutoPutAxis( &
      & dim = 'wn',   array = w_Number )               ! (in)

    ! ɸŤߤ
    ! Axes weights settings
    !
    call HistoryAutoAddWeight( &
      & dim = 'lon', weight = x_Lon_Weight, & ! (in)
      & units = 'radian', xtype = 'double' )  ! (in) optional
    call HistoryAutoAddWeight( &
      & dim = 'lat', weight = y_Lat_Weight, & ! (in)
      & units = 'radian', xtype = 'double' )  ! (in) optional
    call HistoryAutoAddWeight( &
      & dim = 'sig', weight = z_DelSigma, &   ! (in)
      & xtype = 'double' )                    ! (in) optional

#ifdef LIB_MPI
    ! MPI ѻ˥եĤ礷ƽϤ뤿ξͿ
    ! Add information for output to one file when MPI is used
    !
    call HistoryAutoPutAxisMPI( &
      & dim = 'lon',  array = x_Lon_wholeMPI / PI * 180.0_DP )  ! (in)
    call HistoryAutoPutAxisMPI( &
      & dim = 'lat',  array = y_Lat_wholeMPI / PI * 180.0_DP )  ! (in)
    call HistoryAutoPutAxisMPI( &
      & dim = 'sig',  array = z_Sigma_wholeMPI )                ! (in)
    call HistoryAutoPutAxisMPI( &
      & dim = 'sigm', array = r_Sigma_wholeMPI )                ! (in)
    call HistoryAutoPutAxisMPI( &
      & dim = 'wn',   array = w_Number )                        ! (in)

#endif

    !  ; Print
    !
    call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
    call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )

    history_file_io_inited = .true.
  end subroutine HistoryFileOpen

  !-------------------------------------------------------------------

  subroutine HistoryFileClose
    !
    ! ҥȥǡեϤνλԤޤ. 
    !
    ! Terminate history data files output. 

    ! ⥸塼 ; USE statements
    !

    ! gtool4 netCDF ǡϥ󥿡ե (絬ϥǥ)
    ! Interface of Input/Output of gtool4 netCDF data (For large models)
    !
    use gtool_historyauto, only: HistoryAutoClose

    ! ʸ ; Declaration statements
    !
    implicit none

    ! ѿ
    ! Work variables
    !

    ! ¹ʸ ; Executable statement
    !

    call HistoryAutoClose

  end subroutine HistoryFileClose

  !-------------------------------------------------------------------

  subroutine InitCheck
    !
    ! ¸⥸塼νå
    !
    ! Check initialization of dependency modules

    ! ⥸塼 ; USE statements
    !

    ! NAMELIST եϤ˴ؤ桼ƥƥ
    ! Utilities for NAMELIST file input
    !
    use namelist_util, only: namelist_util_inited

    ! ϥեδܾ
    ! Management basic information for output files
    !
    use fileset, only: fileset_inited

    ! ʻ
    ! Grid points settings
    !
    use gridset, only: gridset_inited

    ! ɸǡ
    ! Axes data settings
    !
    use axesset, only: axesset_inited

    ! 
    ! Time control
    !
    use timeset, only: timeset_inited

    ! ¹ʸ ; Executable statement
    !

    if ( .not. namelist_util_inited ) &
      & call MessageNotify( 'E', module_name, '"namelist_util" module is not initialized.' )

    if ( .not. fileset_inited ) &
      & call MessageNotify( 'E', module_name, '"fileset" module is not initialized.' )

    if ( .not. gridset_inited ) &
      & call MessageNotify( 'E', module_name, '"gridset" module is not initialized.' )

    if ( .not. axesset_inited ) &
      & call MessageNotify( 'E', module_name, '"axesset" module is not initialized.' )

    if ( .not. timeset_inited ) &
      & call MessageNotify( 'E', module_name, '"timeset" module is not initialized.' )

  end subroutine InitCheck

end module history_file_io
